image: node:10.16.3

stages:
  - dependencies
  - build
  - test

# Install dependencies
dependencies:
  tags:
    - docker
  stage: dependencies
  script:
    - npm config set registry ${W_NPM_REGISTRY}
    - cd client
    - npm install
  artifacts:
    expire_in: 30 days
    when: on_success
    paths:
      - client/node_modules/

# Build project
build:
  script:
    - cd client
    - npm run build
  tags:
    - docker
  stage: build
  dependencies:
    - dependencies

# Run tests
test:
  script:
    - cd server
    - npm test
  tags:
    - docker
  stage: test
  dependencies:
    - dependencies
